from app.db.base import SessionLocal, engine, Base

def get_db():
    db = SessionLocal()
    try:
        yield db
    finally:
        db.close()

def init_db():
    # Import models to register them with SQLAlchemy
    from app.models.user import User  # noqa: F401
    from app.models.beat import Beat  # noqa: F401
    from app.models.transaction import Transaction  # noqa: F401
    
    Base.metadata.create_all(bind=engine)