from pydantic import BaseModel
from typing import Optional
from datetime import datetime
from app.models.transaction import TransactionStatus

class TransactionBase(BaseModel):
    beat_id: int
    amount: float

class TransactionCreate(TransactionBase):
    pass

class TransactionUpdate(BaseModel):
    status: Optional[TransactionStatus] = None

class TransactionResponse(TransactionBase):
    id: int
    buyer_id: int
    status: TransactionStatus
    transaction_reference: str
    created_at: datetime
    updated_at: datetime

    class Config:
        from_attributes = True